Subject: Re: [PATCH net 1/6] pds_core: Prevent possible adminq overflow/stuck condition

From: Simon Horman <[email-masked]>
Date: Fri, 11 Apr 2025 19:59:08 +0100

On Wed, Apr 09, 2025 at 04:32:26PM -0700, Nelson, Shannon wrote:
> On 4/9/2025 2:37 AM, Simon Horman wrote:
> > 
> > On Mon, Apr 07, 2025 at 03:51:08PM -0700, Shannon Nelson wrote:
> > > From: Brett Creeley <[email-masked]>
> > > 
> > > The pds_core's adminq is protected by the adminq_lock, which prevents
> > > more than 1 command to be posted onto it at any one time. This makes it
> > > so the client drivers cannot simultaneously post adminq commands.
> > > However, the completions happen in a different context, which means
> > > multiple adminq commands can be posted sequentially and all waiting
> > > on completion.
> > > 
> > > On the FW side, the backing adminq request queue is only 16 entries
> > > long and the retry mechanism and/or overflow/stuck prevention is
> > > lacking. This can cause the adminq to get stuck, so commands are no
> > > longer processed and completions are no longer sent by the FW.
> > > 
> > > As an initial fix, prevent more than 16 outstanding adminq commands so
> > > there's no way to cause the adminq from getting stuck. This works
> > > because the backing adminq request queue will never have more than 16
> > > pending adminq commands, so it will never overflow. This is done by
> > > reducing the adminq depth to 16.
> > > 
> > > Fixes: 792d36ccc163 ("pds_core: Clean up init/uninit flows to be more readable")
> > 
> > Hi Brett and Shannon,
> > 
> > I see that the cited commit added the lines that are being updated
> > to pdsc_core_init(). But it seems to me that it did so by moving
> > them from pdsc_setup(). So I wonder if it is actually the commit
> > that added the code to pdsc_setup() that is being fixed.
> > 
> > If so, perhaps:
> > 
> >    Fixes: 45d76f492938 ("pds_core: set up device and adminq")
> 
> Perhaps... is it better to call out the older commit even tho' lines have
> moved around and this possibly won't apply?

Hi Shannon,

Sorry for not answering earlier, somehow I missed your email.

I see your point. But I think that it's best to cite the root cause.